package com.steerinfo.dil.feign;

import com.steerinfo.framework.controller.RESTfulResult;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.Map;

/**
 * @ author    :TXF
 * @ time      :2021/10/27 18:05
 */

@FeignClient(value = "dil-oms-dev", url = "${openfeign.OmsFeign.url}")
public interface OmsFeign {

    //远程调用新增运输订单
    @PostMapping("api/v1/oms/utilscontroller/insertSelectiveOrder")
    RESTfulResult insertSelectiveOrder(@RequestBody(required = false) Map<String, Object> omstruckOrder);

    @PostMapping("api/v1/oms/utilscontroller/updateOmsTruckOrder")
    RESTfulResult updateOmsTruckOrder(@RequestBody(required = false) Map<String,Object> omstruckOrder1);

    //远程调用新增运输订单子表
    @PostMapping("api/v1/oms/utilscontroller/insertSelectiveOrderMaterial")
    RESTfulResult insertSelectiveOrderMaterial(@RequestBody(required = false) Map<String, Object> omstruckOrderMaterial);

    //远程调用推送websocket
    @PostMapping("api/v1/oms/omstruckorderseparates/pushMesToWebsocket")
    RESTfulResult pushMesToWebsocket(@RequestBody(required = false) Map<String, Object> map);
    @PostMapping("api/v1/oms/omstruckorders/pushMessageToDriver")
    public RESTfulResult pushMessageToDriver(@RequestBody Map<String,Object> mapValue);
}
