package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.StatisticalReportMapper;
import com.steerinfo.dil.service.IStatisticalReportService;
import com.steerinfo.dil.util.DataChange;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @ author    :TXF
 * @ time      :2021/12/14 15:26
 */
@Service
public class StatisticalReportImpl implements IStatisticalReportService {

    @Autowired
    StatisticalReportMapper statisticalReportMapper;


    /**
     * 计算相差时间
     * @return
     */
    public void calculateDifferenceTime(Map<String, Object> mesMap){
        Object resultEntryGateTime = mesMap.get("resultEntryGateTime");
        Object resultOutGateTime = mesMap.get("resultOutGateTime");
        if(resultEntryGateTime != null && resultOutGateTime != null){
            Date enterDate = (Date) resultEntryGateTime;
            Date outDate = (Date) resultOutGateTime;
            //计算相差时间
            long dTime = outDate.getTime() - enterDate.getTime();
            mesMap.put("inPlantDwellTime", dTime / 60000 + "分钟");
        }
        if(resultEntryGateTime != null && resultOutGateTime == null){
            //如果没有出厂时间则以当前时间减去进厂时间
            Date enterDate = (Date) resultEntryGateTime;
            long dTime = new Date().getTime() - enterDate.getTime();
            mesMap.put("inPlantDwellTime", dTime / 60000 + "分钟");
        }
    }

    /**
     * 查询采购统计报表
     * @Author TXF
     * @Date 2022/1/6 9:52
     * @param map
     * @return
     **/
    public List<Map<String, Object>> getRLFLReport(Map<String, Object> map){
        List<Map<String, Object>> mapList = statisticalReportMapper.getAllPurchaseFLRLReport(map);
        for (Map<String, Object> mesMap : mapList) {
            calculateDifferenceTime(mesMap);
        }
        return mapList;
    }

    @Override
    public List<Map<String, Object>> getAllPurchaseFLRLReport(Map<String, Object> map) {
        return statisticalReportMapper.getAllPurchaseFLRLReport(map);
    }

    /**
     * 查询销售统计报表
     * @param map
     * @return
     */
    @Override
    public List<Map<String, Object>> getAllSaleReport(Map<String, Object> map) {
        System.out.println(statisticalReportMapper.getAllSaleReport(map));
        List<Map<String, Object>> mapList = statisticalReportMapper.getAllSaleReport(map);
        for (Map<String, Object> mesMap : mapList) {
            calculateDifferenceTime(mesMap);
        }
        return mapList;
    }

    @Override
    public List<Map<String, Object>> getAllSaleReportNum(Map<String, Object> map) {
        return statisticalReportMapper.getAllSaleReport(map);
    }

    /**
     * 查询零星物资进厂统计报表
     */
    @Override
    public List<Map<String, Object>> getSporadicSuppliesReportNum1(Map<String, Object> mapValue) {
        return statisticalReportMapper.getSporadicSuppliesReport1(mapValue);
    }

    @Override
    public List<Map<String, Object>> getSporadicSuppliesReport1(Map<String, Object> mapValue) {
        List<Map<String, Object>> mapList = statisticalReportMapper.getSporadicSuppliesReport1(mapValue);
        for (Map<String, Object> mesMap : mapList) {
            calculateDifferenceTime(mesMap);
        }
        return mapList;
    }

    /**
     * 查询零星物资出厂统计报表
     */
    @Override
    public List<Map<String, Object>> getSporadicSuppliesReportNum2(Map<String, Object> mapValue) {
        return statisticalReportMapper.getSporadicSuppliesReport1(mapValue);
    }

    @Override
    public List<Map<String, Object>> getSporadicSuppliesReport2(Map<String, Object> mapValue) {
        List<Map<String, Object>> mapList = statisticalReportMapper.getSporadicSuppliesReport2(mapValue);
        for (Map<String, Object> mesMap : mapList) {
            calculateDifferenceTime(mesMap);
        }
        return mapList;
    }
}
